# $Id: TextUtils.py,v 1.2 2005/03/27 17:06:43 asc Exp $

__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/ImageWidget/"
__version__    = "1.0"
__cvsversion__ = "$Revision: 1.2 $"
__date__       = "$Date: 2005/03/27 17:06:43 $"
__copyright__  = "Copyright (c) 2004-2005 Aaron Straup Cope. GNU GPL 2"

import sgmllib
import string
import re

rx=re.compile(u"([\u2e80-\uffff])", re.UNICODE)

# From...uh...erm...

class StrippingParser(sgmllib.SGMLParser):

    valid_tags = ();

    from htmlentitydefs import entitydefs # replace entitydefs from sgmllib
    
    def __init__(self):
        sgmllib.SGMLParser.__init__(self)
        self.result = ""
        self.endTagList = [] 
        
    def handle_data(self, data):
        if data:
            self.result = self.result + data

    def handle_charref(self, name):
        self.result = "%s&#%s;" % (self.result, name)
        
    def handle_entityref(self, name):
        if self.entitydefs.has_key(name): 
            x = ';'
        else:
            # this breaks unstandard entities that end with ';'
            x = ''
        self.result = "%s&%s%s" % (self.result, name, x)
    
    def unknown_starttag(self, tag, attrs):
        """ Delete all tags except for legal ones """
        if tag in self.valid_tags:       
            self.result = self.result + '<' + tag
            for k, v in attrs:
                if string.lower(k[0:2]) != 'on' and string.lower(v[0:10]) != 'javascript':
                    self.result = '%s %s="%s"' % (self.result, k, v)
            endTag = '</%s>' % tag
            self.endTagList.insert(0,endTag)    
            self.result = self.result + '>'
                
    def unknown_endtag(self, tag):
        if tag in self.valid_tags:
            self.result = "%s</%s>" % (self.result, tag)
            remTag = '</%s>' % tag
            self.endTagList.remove(remTag)

    def cleanup(self):
        """ Append missing closing tags """
        for j in range(len(self.endTagList)):
                self.result = self.result + self.endTagList[j]

#

def strip_html (html) :
    parser = StrippingParser()
    parser.feed(html)
    parser.close()
    parser.cleanup()

    return unicode(parser.result)

# http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/358117

def wrap(text, width, encoding="utf8"):

    res = reduce(lambda line, word, width=width: '%s%s%s' %              
		 (line,
		  [' ','\n', ''][(len(line)-line.rfind('\n')-1
				  + len(word.split('\n',1)[0] ) >= width) or
				 line[-1:] == '\0' and 2],
		  word),
		 rx.sub(r'\1\0 ', text).split(' ')
		 ).replace('\0', '').encode(encoding)
    
    return unicode(res,encoding)
#

if __name__ == "__main__" :

    txt = u"hello world foo bar baz"
    utxt = wrap(txt,10)

    print utxt

    html = "<p>hello <a href = "">world</a></p>"
    print strip_html(html)
